#!/usr/local/bin/perl

# %W% (%Q%) %G%

# Delivery restriction mailer
# by motonori@wide.ad.jp

# Just a sample of implementation and no warranty (no operational experience)

# This script does not require SUID root.

#$local = "/usr/local/mail";
$local = "/home/prof/motonori/net/cf/CF-3.4W3/support/restriction";
#$lib = "$local/lib";
$lib = "$local";

$list = "$lib/access_list";
$message = "$lib/message";
$log = "$local/log";

# Be sure that standard sendmail.cf is used here.
$sendmail = "/usr/lib/sendmail";

$ENV{'PATH'}="/bin:/usr/bin";

umask(077);

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$now = sprintf("%02d/%02d/%02d %02d:%02d:%02d",
	$year, $mon+1, $mday, $hour, $min, $sec);

$opt = shift;
$src = shift;
#if ($src =~ /^([\w\%\@\.-]+)$/) {
if ($src =~ /^([\w\@\.-]+)$/) {
	$src = $1;	# secure
} else {
	print "554 Insecure sender address string.\n";
	exit 64;	# EX_USAGE
}
foreach $i (@ARGV) {
#	if ($i =~ /^([\w\%\@\.-]+)$/) {	# you may need more characters
	if ($i =~ /^([\w\@\.-]+)$/) {
		push (@dst_list, $1);	# secure
	} else {
		print "554 Insecure recipirnt address string.\n";
		exit 64;	# EX_USAGE
	}
}

if (open(ADDRESS, "<$list")) {
	while(<ADDRESS>) {
		chop;
		next if (/^$/);
		next if (/^#/);
		push(@access_list, $_);
	}
	close(ADDRESS);
}

foreach $dst (@dst_list) {

	$ok = 1;	# default is OK.

	foreach $access (@access_list) {
		@params = split(/\s+/, $access);
		if ($src =~ /^$params[1]$/ && $dst =~ /^$params[2]$/) {
			if ($params[0] =~ /^deny$/i) {
				$ok = 0;
			} else {
				$ok = 1;
			}
			last;
		}
	}
	if ($ok == 1) {
		push(@dst_allow, $dst);
	} else {
		push(@dst_deny, $dst);
	}
	if (open(LOG, ">>$log")) {
		printf LOG "%s: %s from %s to %s\n",
			$now, ($ok ? "allowed" : "denied"), $src, $dst;
		close(LOG);
	}
}

if ($dst_deny[0] ne "") {
	if (open(MAIL, "| $sendmail -f '<>' $src")) {
		print MAIL "Subject: Returned mail: Access denied\n";
		print MAIL "From: MAILER-DAEMON\n";
		print MAIL "To: $src\n";
		print MAIL "\n";

		if (open(MSG, "<$message")) {
			while(<MSG>) {
				print MAIL "    $_";
			}
			close(MSG);
		}

		print MAIL "\n";
		print MAIL "   ----- Transcript of session follows -----\n";
		foreach $dst (@dst_deny) {
			print MAIL "554 Can't deliver to $dst from $src.\n";
		}
		print MAIL "\n";
		print MAIL "   ----- Original message follows -----\n";
		while (<STDIN>) {
			print MAIL $_;
		}
	} else {
		print "554 Can't exec sendmail.\n";
		exit 78;	# EX_CONFIG
	}
}
if ($dst_allow[0] ne "") {
	$dst = join(' ', @dst_allow);
	if (open(MAIL, "| $sendmail -f $src $dst")) {
#		print MAIL "$src $dst\n";
		while (<STDIN>) {
			print MAIL $_;
		}
	} else {
		print "554 Can't exec sendmail.\n";
		exit 78;	# EX_CONFIG
	}
}

exit 0;		# EX_OK
